 rem ---------------------------------------------------------------------------
 rem 
 rem  Poetiru
 rem      by Sebastian Mihai, 2015
 rem      http://sebastianmihai.com
 rem
 rem      (for the Atari 7800)
 rem
 rem  Why "Poetiru"? It has nothing to do with the game, so why
 rem  did I choose it?
 rem
 rem  I chose it because I created this word in a dream where
 rem  I was trying to teach someone else a "foreign language"
 rem  which I was able to speak in that dream.
 rem 
 rem ---------------------------------------------------------------------------

 set doublewide on

 dim frame=a
 dim tempx=b
 dim tempy=c
 rem THIS GOES FROM 0 TO 9, CORRESPONDING TO THE LEVEL NUMBER AS WELL
 dim score=d
 dim palette=e
 dim playerx=f
 dim playery=g
 dim numenemies=h
 dim cupcakecount=i
 dim invulnerable=j
 dim gameislost=k
 dim temp0=l
 
 dim enemyx=$2200
 dim enemyy=$2220
 dim enemydx=$2240
 dim enemydy=$2260
 dim cupcakex=$2280
 dim cupcakey=$2290
 dim cupcakestate=$22A0
 
 incgraphic gfx/back.png
 incgraphic gfx/bear0.png
 incgraphic gfx/bear1.png
 incgraphic gfx/cupcake.png
 incgraphic gfx/enemy0.png
 incgraphic gfx/enemy1.png
 incgraphic gfx/font.png
  
 characterset back

 BACKGRND=$03
 frame = 0
 
 gosub init_palettes
  
 clearscreen
 plotmap screen1map 0 0 0 20 12
 drawscreen
 savescreen

 rem ---------------------------------------------------------------------------
 rem START HERE AFTER A GAME LOSS OR VICTORY
 rem ---------------------------------------------------------------------------
new_game
 numenemies = -1
 
 rem ---------------------------------------------------------------------------
 rem COME HERE WHENEVER STARTING A NEW LEVEL
 rem ---------------------------------------------------------------------------
game_loop
 numenemies = numenemies + 1

 rem IF 9TH LEVEL WAS CLEARED, THE GAME IS WON
infinite_loop_when_won
 if numenemies = 10 then goto infinite_loop_when_won

 rem ---------------------------------------------------------------------------
 rem COME HERE AFTER BEING HIT BY AN ENEMY
 rem ---------------------------------------------------------------------------
game_loop_after_losing
 gameislost = 0
 gosub init_enemies
 gosub init_cupcakes
 score = numenemies
 playerx = 72
 playery = 86
 invulnerable = 1

 rem ---------------------------------------------------------------------------
 rem THIS IS THE START OF EVERY VIDEO FRAME
 rem ---------------------------------------------------------------------------
level_loop
 restorescreen
 cupcakecount = 4
 frame = frame + 1
 
 gosub update_enemies
 gosub update_player
 
 if invulnerable = 1 then goto level_loop_display
 
 gosub check_eaten_cupcakes
 gosub check_enemy_collision

level_loop_display 
 gosub display_cupcakes
 gosub display_enemies
 gosub display_score
 gosub display_player
 
 drawscreen
 
 rem WAS THE GAME LOST?
 if gameislost = 1 then goto game_loop_after_losing
 
 rem ADVANCE RANDOM SEQUENCE TO INTRODUCE RANDOMNESS
 tempx = rand

 if cupcakecount = 0 then goto game_loop
 
 goto level_loop



 rem ---------------------------------------------------------------------------
 rem PROCEDURES FROM HERE ON
 rem ---------------------------------------------------------------------------
 


 rem ---------------------------------------------------------------------------
 rem DISPLAYS THE SINGLE-DIGIT SCORE (WHICH ALSO REPRESENTS CURRENT LEVEL)
 rem ---------------------------------------------------------------------------
display_score
 characterset font
 palette=1
 tempx = 112
 tempy = 11
 if score = 0 then plotchars ' a' palette tempx tempy
 if score = 1 then plotchars 'bc' palette tempx tempy
 if score = 2 then plotchars 'de' palette tempx tempy
 if score = 3 then plotchars 'fg' palette tempx tempy
 if score = 4 then plotchars 'hi' palette tempx tempy
 if score = 5 then plotchars 'jk' palette tempx tempy
 if score = 6 then plotchars 'lm' palette tempx tempy
 if score = 7 then plotchars 'no' palette tempx tempy
 if score = 8 then plotchars 'pq' palette tempx tempy
 if score = 9 then plotchars 'rs' palette tempx tempy
 
 tempx = tempx + 16
 plotchars 'tu' palette tempx tempy
 tempx = tempx + 16
 plotchars 'rs' palette tempx tempy
 return
 
 rem ---------------------------------------------------------------------------
 rem MOVE ENEMIES EVERY FRAME
 rem --------------------------------------------------------------------------- 
update_enemies
 if numenemies = 0 then return
 for z=1 to numenemies
   tempx=enemyx[z]+enemydx[z]
   tempy=enemyy[z]+enemydy[z]
   if tempx<2 then enemydx[z]=1
   if tempx>145 then enemydx[z]=-1
   if tempy<2 then enemydy[z]=1
   if tempy>172 then enemydy[z]=-1
   enemyx[z]=tempx
   enemyy[z]=tempy
 next z
 return

 rem ---------------------------------------------------------------------------
 rem READ INPUT AND MOVE PLAYER. COME OUT OF INVULNERABLE STATE IF NEEDED
 rem ---------------------------------------------------------------------------
update_player
 if invulnerable = 0 then goto update_player_can_move
 if joy0fire0 then invulnerable = 0
 return
update_player_can_move
 if joy0up then playery = playery - 1
 if joy0down then playery = playery + 1
 if joy0left then playerx = playerx - 1
 if joy0right then playerx = playerx + 1
 
 if playerx <= 1 then playerx = 1
 if playerx >= 146 then playerx = 146
 if playery <= 1 then playery = 1
 if playery >= 173 then playery = 173
 return
 
 rem ---------------------------------------------------------------------------
 rem RENDER ALL ENEMIES
 rem ---------------------------------------------------------------------------
display_enemies
 if numenemies = 0 then return
 
 palette=5
 for z=1 to numenemies
   tempx=enemyx[z]
   tempy=enemyy[z]
   
   rem ANIMATE ENEMY
   if frame & 4 = 0 then goto display_enemies_other_frame
   plotsprite enemy0 palette tempx tempy
   goto display_enemies_next
display_enemies_other_frame 
   plotsprite enemy1 palette tempx tempy
display_enemies_next
 next
 return 
 
 rem ---------------------------------------------------------------------------
 rem RENDER ALL CUPCAKES
 rem ---------------------------------------------------------------------------
display_cupcakes
 palette=4
 
 rem THIS WILL MAKE CUPCAKES BOUNCE ON SCREEN
 temp0 = 0
 if frame & 8 = 0 then temp0 = 3
 
 for z=0 to 3
   tempx=cupcakex[z]
   tempy=cupcakey[z] + temp0
   if cupcakestate[z] = 1 then plotsprite cupcake palette tempx tempy
 next
 return
 
 rem ---------------------------------------------------------------------------
 rem RENDER PLAYER
 rem ---------------------------------------------------------------------------
display_player
 palette = 3
 if invulnerable = 1 then palette = 2
 if invulnerable = 1 then goto display_player_other_frame
 
 rem ANIMATE
 if frame & 8 = 0 then goto display_player_other_frame
 plotsprite bear0 palette playerx playery
 goto display_player_return
display_player_other_frame
 plotsprite bear1 palette playerx playery
display_player_return
 return

 rem ---------------------------------------------------------------------------
 rem WAS THERE COLLISION BETWEEN PLAYER AND ANY CUPCAKE?
 rem ---------------------------------------------------------------------------
check_eaten_cupcakes
 for z=0 to 3
   tempx = cupcakex[z]
   tempy = cupcakey[z]
   if boxcollision(playerx, playery, 16, 16, tempx, tempy, 16, 16) then cupcakestate[z] = 0
   if cupcakestate[z] = 0 then cupcakecount = cupcakecount - 1
 next
 return

 rem ---------------------------------------------------------------------------
 rem WAS THERE COLLISION BETWEEN PLAYER AND ANY ENEMIES?
 rem ---------------------------------------------------------------------------
check_enemy_collision
 if numenemies = 0 then return
 for z=1 to numenemies
   tempx = enemyx[z]
   tempy = enemyy[z]
   if boxcollision(playerx, playery, 16, 16, tempx, tempy, 16, 16) then gameislost = 1
 next
 return

 
 rem ---------------------------------------------------------------------------
 rem INITIALIZATION ROUTINES FROM HERE ON
 rem ---------------------------------------------------------------------------

 
init_palettes
  rem BG PALETTE
  P0C1=$b2
  P0C2=$04
  P0C3=$01

  rem FONT PALETTE
  P1C1=$a9
  P1C2=$ab
  P1C3=$bd

  rem INVULNERABLE PLAYER PALETTE
  P2C1=$04
  P2C2=$08
  P2C3=$0c

  rem PLAYER PALETTE
  P3C1=$00
  P3C2=$15
  P3C3=$17

  rem CUPCAKE PALETTE
  P4C1=$24
  P4C2=$5a
  P4C3=$64
  
  rem ENEMY PALETTE
  P5C1=$db
  P5C2=$0f
  P5C3=$60
  
  return

  
  
init_enemies
 if numenemies = 0 then return
 for z=1 to numenemies
    enemyx[z]=rand&127
    enemyy[z]=rand&127
    
	rem EITHER -1 OR 1
	enemydx[z]=(rand&2)-1
    enemydy[z]=(rand&2)-1
  next
  return
  

init_cupcakes
 cupcakex[0] = 20
 cupcakey[0] = 20
 
 cupcakex[1] = 126
 cupcakey[1] = cupcakey[0]
 
 cupcakex[2] = cupcakex[0]
 cupcakey[2] = 154
 
 cupcakex[3] = cupcakex[1]
 cupcakey[3] = cupcakey[2]
 
 for z=0 to 3
   rem MAKE ON SCREEN
   cupcakestate[z] = 1
 next
 return 
 
 
 alphachars ' abcdefghijklmnopqrstuvwxyz'

 alphadata screen1map back
 ' bbb     cc       fg'
 '  b           de    '
 '      cb            '
 ' de         c       '
 '   bc               '
 '        b        bc '
 '   cc      de       '
 'bc         b        '
 '    b               '
 '       c      bcb   '
 ' cbc                '
 'de         bc       '
end
